{
===============================================================================
  Copyright (©) 2001. Rodax Software.
===============================================================================
  Los contenidos de este fichero son propiedad de Rodax Software titular del
  copyright. Este fichero sólo podrá ser copiado, distribuido y utilizado,
  en su totalidad o en parte, con el permiso escrito de Rodax Software, o de
  acuerdo con los términos y condiciones establecidas en el acuerdo/contrato
  bajo el que se suministra.
  -----------------------------------------------------------------------------
  Web:  www.rodax-software.com
===============================================================================
  Fecha primera versión: 01-10-2001
  Versión actual: 1.0.0
  Fecha versión actual: 01-10-2001
===============================================================================
  Modificaciones:

    Fecha         Comentarios
    ---------------------------------------------------------------------------
===============================================================================
}

unit BuscarArticuloAlmacen;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, IBQuery, StdCtrls, DB, RdxBotones,  RdxBarras, RdxComboBox,
  RdxCampos,  RdxTitulos, RdxPaneles, Tipos, Mensajes,
  RdxFrame, RdxDBFrame, RdxFrameArticulosAlmacen;


type
  TfrBuscarArticuloAlmacen = class(TRdxFrameArticulosAlmacen)
    brBuscar: TRdxBarraInferior;
    bBuscar: TRdxBoton;
    bCerrar: TRdxBoton;
    RdxPanel1: TRdxPanel;
    RdxCabecera1: TRdxCabecera;
    eCodigo: TLabel;
    eFamilia: TLabel;
    eDescripcion: TLabel;
    Codigo: TRdxEdit;
    cbxFamilia: TRdxComboBox;
    Descripcion: TRdxEdit;
    procedure bCerrarClick(Sender: TObject);
    procedure bBuscarClick(Sender: TObject);
    procedure RecogerDatos;
  protected
    procedure BuscarArticulo; override;
    procedure BuscarAlmacen; override;
    function CloseFrame : boolean; override;
    function CambiarEntidad (EntidadAnterior, Entidad : TRdxEntidad): Boolean; override;        
  public
    constructor Create (AOwner : TComponent); override;
  published
    property TablaArticulosAlmacen;
    property CodigoAlmacen;
    property CodigoArticulo;
  end;

var
  frBuscarArticuloAlmacen: TfrBuscarArticuloAlmacen;

implementation

{$R *.DFM}

uses
  BaseDatos, ArticulosAlmacen, TablaFamilias, Configuracion, Literales;

var
  Campos : String;
  Valores : Variant;
  Contador : Integer;

constructor TfrBuscarArticuloAlmacen.Create (AOwner : TComponent);
begin
  if not (AOwner is TRdxFrameArticulosAlmacen) then
    exit;
  inherited Create(AOwner);
  Entidad := entArticuloAlmacen;
  ConfigurarFrame(Self, Self.Entidad);

  Contador := -1;
  Campos := '';
  Valores := VarArrayOf([null, null, null]);

  cbxFamilia.Items := dmTablaFamilias.darFamilias;
  TablaArticulosAlmacen := (AOwner as TRdxFrameArticulosAlmacen).TablaArticulosAlmacen;
  with TablaArticulosAlmacen do begin
    Codigo.MaxLength := FieldByName('CODIGOARTICULO').Size;
    Descripcion.MaxLength := FieldByName('DESCRIPCION').Size;
  end;
end;

procedure TfrBuscarArticuloAlmacen.bCerrarClick(Sender: TObject);
begin
  inherited;
  CloseFrame;
end;

procedure TfrBuscarArticuloAlmacen.RecogerDatos;
begin
  Campos := '';
  Contador := -1;

  if Length(Trim(Codigo.Text)) > 0 then
  begin
    Contador := Contador + 1;
    Campos := Campos + 'CODIGOARTICULO';
    Valores[Contador] := Trim(Codigo.Text);
  end;

  if Length(Trim(Descripcion.Text)) > 0 then
  begin
    Contador := Contador + 1;
    if Contador > 0 then
      Campos := Campos + ';';
    Campos := Campos + 'DESCRIPCION';
    Valores[Contador] := Trim(Descripcion.Text);
  end;

  if Length(Trim(cbxFamilia.Text)) > 0 then
  begin
    Contador := Contador + 1;
    if Contador > 0 then
      Campos := Campos + ';';
    Campos := Campos + 'FAMILIA';
    Valores[Contador] := Trim(cbxFamilia.Text);
  end;
end;

procedure TfrBuscarArticuloAlmacen.bBuscarClick(Sender: TObject);
begin
  RecogerDatos;
  if Contador <> -1 then
    BuscarArticulo
  else
    VerMensaje(msgNoParametros);
end;

procedure TfrBuscarArticuloAlmacen.BuscarArticulo;
var
  Respuesta : integer;
  Resultado : Boolean;
begin
  if Contador <> -1 then begin
    TablaArticulosAlmacen.DisableControls;

    if Contador = 0
    then Resultado := TablaArticulosAlmacen.LocateNext(Campos, Valores[Contador], [loCaseInsensitive, loPartialKey])
    else Resultado := TablaArticulosAlmacen.LocateNext(Campos, Valores, [loCaseInsensitive, loPartialKey]);
    if (Resultado = false) then
    begin
        Respuesta := VerMensajePregunta(msgIrInicio);
        case Respuesta of
          IDYES: TablaArticulosAlmacen.First;
        end;
    end;
    TablaArticulosAlmacen.EnableControls;
  end;
end;

procedure TfrBuscarArticuloAlmacen.BuscarAlmacen;
begin
//
end;

function TfrBuscarArticuloAlmacen.CloseFrame: boolean;
begin
  FCodigoAlmacen := TablaArticulosAlmacen.FieldByName('CODIGOALMACEN').AsString;
  FCodigoArticulo := TablaArticulosAlmacen.FieldByName('CODIGOARTICULO').AsString;
  Result := inherited CloseFrame;
end;

function TfrBuscarArticuloAlmacen.CambiarEntidad(EntidadAnterior,
  Entidad: TRdxEntidad): Boolean;
begin
  if not inherited CambiarEntidad(EntidadAnterior, Entidad) then
    Exit;

  ConfigurarFrame(Self, Self.Entidad);
end;

end.
